;				FICHIER DU 03/04/06
;	consomes.ASM	utilise un afficheur  2 lignes de 16 caractres
; La puissance du systme sous surveillance est entre en E2PROM
; On travaille avec un quartz de 3,2768MHz  
; Cette version fonctionne sur gold_cap. On sauvegarde en E2PROM la conso
; partielle si on a une panne de plus de 2,56s ce qui limine les micro coupures.
; la conso max enregistrable est de  99999,999 KWh. Ensuite il y a retour  0

	list	p=16f84		;	
	#include p16f84.inc

	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC ; avant config double soulignement


; directives assembleur	pour aller + vite et mieux comprendre ce qui est test ou impos	

#define	testc	STATUS,C	; testc pour tester le bit C (= carry ) de STATUS
#define	testz	STATUS,Z	; testz remplace STATUS,Z
#define	banq	STATUS,RP0	; banq remplace STATUS,RP0	etc...

#define mes_i	PORTA,3		; entre de dtection de courant passe  0 pendant conso
#define	sect_on	PORTA,4		; ce bit est  1 tant que le secteur est prsent

#define ledcons	PORTB,0		; sortie pour led de visu de conso en cours
#define	alim_af	PORTB,1		; bit utilis pour alimenter l'afficheur
#define	LCD_E	PORTB,2		; entre de validation du LCD
#define	LCD_RS	PORTB,3		; slection des registres du LCD
#define	LCD_B4	PORTB,4		; bus de donnes du LCD (mode 4 bits)
#define	LCD_B5	PORTB,5		; "		"
#define	LCD_B6	PORTB,6		; "		"
#define	LCD_B7	PORTB,7		; "		"

#define	sep_ud	temoin,0	; mis  un pour afficher un nombre bcd avec une virgule
#define	bitvar	temoin,1	; tampon de modif d'un bit tmoin dans modbit utilis ds af_ud
#define	t_afct	temoin,2	; mettre  1 pour afficher la conso totale, 0 pour partielle
#define	t_adwh	temoin,3	; mis  1 en IT afin d'afficher les modifs de conso et de NBJ
#define poids_f	temoin,4	; si  1 transmission du quartet haut d'un octet vers AFFICHEUR
#define	retenue	temoin,5	; passe  1 quand l'addition de 2 nb BCD dpasse 99
#define	pass	temoin,6	; bit mis  1 pour indiquer la fin d'criture en E2P

#define	t_modp	temoin1,0	; mis  1 pendant la modif de P pour afficher les variations
#define t_pauxi	temoin1,4	; sert  l'addition d'une puissance < P_KW dans aug_cp
#define	tmesi_v	temoin1,5	; donne l'tat de la conso (en cours ou pas) avant une IT 

#define	t_oui	temcla,0	; =1 aprs action sur touche 	oui
#define t_non	temcla,1	; =1 aprs action sur touche 	non
#define	t_val	temcla,2	; =1 				VALIDATION
#define	t_oetv	temcla,3	; =1 				OUI & VALIDATION en mm temps

#define	bk1	blank,0		; mis  1 il blanchit l'affichage des dizaines d'un nb
#define bk2	blank,1		; mis  1 			  des units d'un nb<100

; liste et adresses des registres en RAM

BT1	equ 	0x10		; compte jusqu' 225 IT pour arriver  18 secondes
BT2	equ 	0x11		; avec son bit 1 quand il est  "1" dfinit la BT de 36secondes
BT_pan	equ	0x12		; utilis en it pour dtecter les pannes de dure > 1,44s
nboucl	equ	0x13		; comptage du nb de fois ou clavier = 0
w_temp	equ	0x14		; pour y sauvegarder w pendant les it
status_temp	equ 0x15	; pour y sauvegarder status pendant les it
clava	equ	0x16		; contient le rsultat de l'appui sur le clavier
clavn	equ	0x17		; tat du clavier en cours de saisie
tampon	equ	0x18		; reoit un octet (donne ou commande) pour l'afficheur
count	equ 	0x19		; utilis dans af_lign
nbcar	equ	0x1A		; nb de caractres d'un message
durap	equ	0x1B		; dure d'appui sur une touche pour modification d'une variable
durinac	equ	0x1C		; dure d'inactivit dans les menus (initialise  4 soit 72s)
pauxi	equ	0x1D		; fraction de P  ajouter dans aug_cp
randata	equ	0x1E		; utilis pour stockage et addition de CT et CP
blank	equ	0x1F		; tmoins pour l'affichage ou non des "0" sur l'Afficheur

ms1	equ 	0x20		; contient le nb de fois 1ms  dcompter dans une tempo
cnt	equ 	0x21		; utiliss par le sous prog ms_1 (tempo de 1ms)
ms10	equ	0x22		; contient le nb de fois 10ms  dcompter dans une tempo

posicur	equ	0x23		; contient l'adresse du curseur sur l'afficheur

consop1	equ	0x25		; unit et dizaines de wh de la conso partielle
consop2	equ	0x26		; centaine de Wh et unit de KWh
consop3	equ	0x27		; 
consop4	equ	0x28		; poids le plus fort de la conso partielle

consov	equ	0x29		; place mmoire pour des calculs et oprations temporaires
				
temoin	equ	0x2D		; 
temcla	equ	0x2E		; 
temoin1	equ	0x2F		; contient t_modp qui signale P en cours de modif

var1	equ	0x30		; utilise dans modvar 
var2	equ	0x31		; utilise dans modvar 
var3	equ	0x32		; "	"	modvar
var4	equ	0x33		; 		cv_bcd et af_du
var5	equ	0x34		; 		cv_bcd et af_du
demi_p	equ	0x35		; contient la moiti de p_kw
quart_p	equ	0x36		; contient le quart de p_kw

mess1	equ	0		; rang du message 1 		CP=
mess2	equ	.5		; rang du message 2		CT= 
mess3	equ	.10		;		  3		KWh
mess4	equ	.15		;		  4		STOCKER CONSO
mess5	equ	.30		; 		  5		O/N? + V
mess6	equ	.40		; 		  6		MODIFICATION DE
mess7	equ	.57		;		  7		P=
mess8	equ	.61		;		  8		ENTRER DATE
mess9	equ	.74		;		  9		CORRIGER DATE
mess10	equ	.89		;		  10		CUMUL DES CONSO
mess11	equ	.106		;		  11		EN COURS
mess12	equ	.116		;		  12		TERMINE

; constantes et position des variables sur l'afficheur 

poswh	equ	0x03		; position de la conso en crivant par la gauche
pmin	equ	.10		; valeur de p mini en dci KW
pmax	equ	.99		; valeur de p maxi en dci KW
posdate	equ	0x48
pospuis	equ	0x44		; place curseur (sur 1/10e P) pour modif de la puissance 
posJJ	equ	0x49		; place de l'unit des variables jour puis mois et
posMM	equ	0x4C		; anne pour la phase de modif
posAA	equ	0x4F		; 

; nom et adresse des variables en E2PROM

date_i	equ	0		; sur 3 octets date_ini: jour_i =0, mois_i = 1 et an_i = 2
p_kw	equ	.3		; contient la puissance en dci-KW
consot1	equ	.4		; cette variable occupe 4 octets successifs de 4  8
date_c	equ	.8		; sur 3 octets date_courante de dbut de conso partielle
consope	equ	.11		; adresse de stockage de la conso partielle 
F_panne	equ	.15		; variable mise  1 s'il y a eu panne secteur

; *******************************************************************************************
;
; Remplissage de l'E2PROM par l'assembleur pour 1 utilisation.
;
; *******************************************************************************************

	org	H'2100'		; adresse de dpart du pr-remplissage de l'E2PROM 

	de	.1, 4, 6	; jour - mois - anne (= date de 1 mise en service)
				; par exemple 16/03/06 ici
	de	.60		; puissance (note p_kw) initialise  6,0KW=60 dciKW ici
	de	0, 0, 0, 0	; consommation totale en E2PROM Le 1 octet contient l'unit
				; et les dizaines de wh, le 2 centaines de WH et unit de KWh
	de	.3, .4,.6	; date de stockage de la conso partielle (ex 25 mars 2006)
	de	0, 0, 0, 0	; valeur de la conso partielle initialise
	de	0		; flag F_panne. Est  1 s'il vient d'y avoir une panne sinon
				; est remis  zro aprs reset automatique.

; ********************************************************************************
; 		vecteurs de dmarrage et d'interruption
;*********************************************************************************
	org	0		; ne pas mettre 0x000 sinon PB
	goto 	DEBUT		

	org 	4		; ne pas mettre 0x004 sinon pB
	goto	gest_it		; vecteur d'it

;***********************************************************************************
; 				dbut des messages affichs  l'cran
;	Le 1 retlw donne la position sur l'afficheur 	0x0n 1 ligne colone n
;							0x4n 2 ligne colone n
;	Le 2	    donne le nombre de caractres du message (3 carac pour CP=)
;	Le 3 et les suivants constituent le contenu du message  afficher
;***********************************************************************************
mess	addwf	PCL,1		; 

	retlw	0x00		; 	MESSAGE 1 ==> mess1=0 		" CP= "
	retlw	.3		; ce 1 message  pour rang "0", il contient 3 caractres	
	retlw	'C'		; il sera plac sur la ligne suprieure en 1 case (0x00)
	retlw	'P'
	retlw	'='		;

	retlw	0x00
	retlw	.3		; 	MESSAGE 2 ==> mess2=.5		" CT= "
	retlw	'C'
	retlw	'T'		; plac sur la ligne suprieure en 1 case (0x00)
	retlw	'='

	retlw	0x0D		; 
	retlw	.3		;  	MESSAGE 3 ==> mess3=.10		" KWh "
	retlw	'K'		; 
	retlw	'W'		; 
	retlw	'h'

	retlw	0x01		;	MESSAGE 4 ==> mess4 = .15	" STOCKER CONSO "	
	retlw	.13		
	retlw	'S'	
	retlw	'T'
	retlw	'O'
	retlw	'C'
	retlw	'K'
	retlw	'E'
	retlw	'R'
	retlw	' '
	retlw	'C'
	retlw	'O'
	retlw	'N'
	retlw	'S'
	retlw	'O'

	retlw	0x48		; 	MESSAGE 5 ==> mess5 = .30	" O/N? + V "		
	retlw	.8
	retlw	'O'
	retlw	'/'
	retlw	'N'
	retlw	'?'
	retlw	' '
	retlw	'+'
	retlw	' '
	retlw	'V'

	retlw	0x00		;	MESSAGE 6==> mess6 = .40	" MODIFICATION DE "
	retlw	.15
	retlw	'M'			
	retlw	'O'
	retlw	'D'
	retlw	'I'
	retlw	'F'
	retlw	'I'
	retlw	'C'
	retlw	'A'
	retlw	'T'
	retlw	'I'
	retlw	'O'
	retlw	'N'
	retlw	' '
	retlw	'D'
	retlw	'E'

	retlw	0x40		;	MESSAGE 7==>	mess7=.57	" P= "
	retlw	.2
	retlw	'P'
	retlw	'='

	retlw	0x02		;	MESSAGE 8==> mess8 = .61	" ENTRER DATE "
	retlw	.11
	retlw	'E'			
	retlw	'N'
	retlw	'T'
	retlw	'R'
	retlw	'E'
	retlw	'R'
	retlw	' '
	retlw	'D'
	retlw	'A'
	retlw	'T'
	retlw	'E'

	retlw	0x01		;	MESSAGE 9==> mess9 = .74	" CORRIGER DATE "
	retlw	.13
	retlw	'C'
	retlw	'O'
	retlw	'R'			
	retlw	'R'
	retlw	'I'
	retlw	'G'
	retlw	'E'
	retlw	'R'
	retlw	' '
	retlw	'D'
	retlw	'A'
	retlw	'T'
	retlw	'E'
	
	retlw	0x00		;	MESSAGE 10 ==> mess10 = .89	" CUMUL DES CONSO "
	retlw	.15
	retlw	'C'
	retlw	'U'
	retlw	'M'			
	retlw	'U'
	retlw	'L'
	retlw	' '
	retlw	'D'
	retlw	'E'
	retlw	'S'
	retlw	' '
	retlw	'C'
	retlw	'O'
	retlw	'N'
	retlw	'S'
	retlw	'O'

	retlw	0x44		;	MESSAGE 11==> mess11 =.106	"EN COURS"
	retlw	.8
	retlw	'E'
	retlw	'N'
	retlw	' '			
	retlw	'C'
	retlw	'O'
	retlw	'U'
	retlw	'R'
	retlw	'S'

	retlw	0x44		;	MESSAGE 12==> mess12 =.116	"TERMINE "
	retlw	.8
	retlw	'T'
	retlw	'E'
	retlw	'R'			
	retlw	'M'
	retlw	'I'
	retlw	'N'
	retlw	'E'
	retlw	' '


;**************************************************************************************
;	**** SP clavier : on en ressort avec l'tat du clavier dans clava 	*******
; 			aprs le relchement de toutes les touches, clava contient 
; le plus grand code saisi "V"=4, "+"=2 "-"=1 et aussi l'addition si 2 touches actives
;**************************************************************************************

clavier	call	lecclav
	movwf	clava
	clrf	nboucl
	bsf	nboucl,1	; init dtection de clavier relch mis  2

clavi_1	call	lecclav
	movwf	clavn		; le tout passe dans clavn (W contient aussi clavn)
	btfss	testz
	goto	clavi_2		; clavn non nul
	decfsz	nboucl,1	; clavn nul ==> test 2 fois si nul avant sortie
	goto	clavi_1		; 1 boucle donc effectuer une 2 boucle

; ****	dtermination des touches actives maintenant qu'elles sont relches.
;	si touche	 OUI active, on met le bit	t_oui    1
;	si touche	 NON				t_non    1
;	"	"	Validation			t_valid  1		
;	"	"	Oui + Valid			t_oetv	 1

res_cla	clrf	temcla		; On met tous les bits tmoins d'action clavier  0
ac_oui	movlw	.2		; par dfaut
	subwf	clava,0
	btfss	testz
	goto	ac_non
	bsf	t_oui
	goto	cla_fin

ac_non	movlw	.1		; on teste quelle touche a t active et on positionne
	subwf	clava,0		; le bit associ  1 si la touche avait t active
	btfss	testz		; pour les combinaisons non tudies, elles sont 
	goto	ac_val		; sans intrt ici. Donc pas de bit associ.
	bsf	t_non
	goto	cla_fin

ac_val	movlw	.4
	subwf	clava,0
	btfss	testz
	goto	ac_oetv
	bsf	t_val
	goto	cla_fin

ac_oetv	movlw	.6		; Touches OUI et Valid actionnes en mme temps
	subwf	clava,0
	btfsc	testz
	bsf	t_oetv

cla_fin	return

clavi_2	subwf	clava,0		; clava - clavn mis dans W
	btfsc	testc
	goto	clavi_1		; C=1 (clava >= clavn) clava inchang 
	movf	clavn,0		; C=0 (clava < clavn) donc clava reoit clavn
	movwf	clava
	goto	clavi_1

;***********************************************************************************
;	lecclav		lecture du clavier et retour dans W de son contenu
;***********************************************************************************

lecclav	movlw	.8		; attente de 8ms avant relecture
	call	ms_1
	movf	PORTA,0		; porta mis dans W
	andlw	0x07		; le masque 07 donne l'tat des bits 0, 1, 2
	return

;***********************************************************************************
;		at_clav		attente d'action sur le clavier
; on y teste "durinac" (dcrment par les IT toutes les 36s) (maxi 4x18s=72s)
; quand cette variable devient nulle, on sort de l'attente et on retourne afficher
; l'cran normal de la conso partielle.
;***********************************************************************************

at_clav	movf	durinac,1	; test de durinac pour sortir des menus en cas 
	btfsc	testz		; d'inaction prolonge plus de 1mn 12s
	goto	aff_1		; durinac=0 
	movf	PORTA,0		; porta masqu par 0x07 donne l'tat du clavier
	andlw	0x07
	btfsc	testz		; clavier est il nul?
	goto	at_clav		; ici, oui, donc on boucle pour attendre une action
	return			; Z non gal  1 donc il y a eu action clavier 

;***********************************************************************************
;		programme excut en cas d'interruption				****
;***********************************************************************************

gest_it	bsf	banq
	btfss	EECON1,EEIF	; est ce une it lie  l'criture en E2PROM ?
	goto	it_tim		; non donc c'est une it timer

	bcf	EECON1,WREN	; ce bit doit tre remis  0
	bcf	EECON1,EEIF	; le tmoin de l'it d'criture doit tre remis  zro

	bcf	banq		; pendant toute l'criture, on travaille sur des 
				; registres en banq 1, il faut donc revenir en banq 0
				; en sortant d'ici les it son interdites

	bsf	pass		; pass mis  1 pour quitter la boucle d'attente de
	retfie			; fin d'criture dans le sp ph_wre2

; la routine d'it timer dbute ici et on commence par sauver les registres W et status
; pour la routine d'it d'criture en E2PROM, W et status ne sont pas utiliss.

it_tim	bcf	banq
	movwf	w_temp		; sauvegarde de W dans w_temp
	swapf	STATUS,0	; sauvegarde status (invers) dans w sans modif bit z
	movwf	status_temp	; puis dans status_temp
	
 	bcf	INTCON,T0IF	; autoriser   nouveau l'it-timer

; ***	test de mes_i et tmesi_v pour savoir si on dbute ou arrte une phase de conso
; ***	afin de ne pas ajouter P_KW en entier mais seulement une fraction fonction de
; ***	la dure coule depuis la dernire priode de 36 secondes; c'est t_pauxi=1
; ***	qui fera ajouter une puissance "pauxi" < P_KW

	btfsc	mes_i
	goto	constop		; mes_i=1 donc soit pas de conso soit arrt de conso
	btfss	tmesi_v
	goto	it_norm		; conso en cours donc traitement normal

depcon0	clrf	pauxi
	btfsc	BT2,0		; ici tmesi_v=1 et mesi=0 donc dbut de conso
	goto	depcon1
	movf	demi_p,0
	movwf	pauxi		; mettre p_kw/2 dans pauxi 

depcon1	movlw	.112
	subwf	BT1,0		; calcul de BT1-112 si >0 C=1 donc ajouter P/4  pauxi
	btfss	testc	
	goto	depcon2		; si C=0 ne rien ajouter  pauxi
	movf	quart_p,0	; ajouter p_kw/4 dans W
	addwf	pauxi,1

depcon2	bcf	tmesi_v
	bsf	t_pauxi		; pour aug_cp
	movlw	0x0c		; position du curseur juste avant "KWh" pour indiquer
	call	pos_cur		; qu'il y a consommation par son clignotement
	goto	it_norm

constop	btfsc	tmesi_v
	goto	it_norm		; pas de conso ni maintenant ni avant

	clrf	pauxi
	btfss	BT2,0		; ici tmesi_v=0 et mesi=1 donc fin de conso
	goto	consto1
	movf	demi_p,0
	movwf	pauxi		; mettre p_kw/2 dans pauxi 

consto1	movlw	.112
	subwf	BT1,0		; calcul de BT1-112 si >0 C=1 donc ajouter P/4  pauxi
	btfsc	testc	
	goto	consto2		; si C=0 ne rien ajouter  pauxi
	movf	quart_p,0		; ajouter p_kw/4 dans W
	addwf	pauxi,1
consto2	bsf	tmesi_v
	bsf	t_pauxi		; pour additionner pauxi au lieu de p_kw dans aug_cp
	bsf	t_adwh		; pour forcer l'addition

; ***	fin des tests de dbut de conso et d'arrt de conso, retour au traitement
 	
it_norm	decf	BT1,1		; si on arrive  zro, 18s se sont coules
	btfss	testz		;
	goto	it_timf		; tant qu'on n'a pas 18s les BTn ne changent pas 
 	movlw	.225		; on recharge BT1  225 car 18s se sont coules
	movwf	BT1		; et donc on dcrmentera aussi BT2

it_tim1 decf	BT2,1
	btfsc	BT2,0		; si le 1 bit de BT2 est  "0", 36s se sont coules
	goto	it_timf		; pas ici, donc on laisse s'couler le temps
	btfsc	mes_i		; si mes_i=1 pas de conso en cours donc CP inchange
	goto	it_tim2		; ici pas de conso donc ledconso sera  0

; ***	ici on doit augmenter CP et on allume le tmoin de conso car mes_i=0.
; ***	le bit t_adwh mis  1 doit permettre d'augmenter CP et ==> affichage

	bsf	t_adwh		; utilis pour augmenter la conso et refaire affichage

it_tim2	movf	durinac,1	; toutes les 36s si durinac est non nul on le dcrmente
	btfss	testz		; pour ne pas rester n'importe o dans le programme
	decf	durinac,1	; quand on est entr dans le menu de stockage

	movf	BT2,1		; on lit BT2 pour savoir si on est arriv  zro
	btfss	testz		;
	goto	it_timf		; si BT2 non nul, on n'a pas une heure d'coule
 	movlw	.200		; on recharge BT2  200 pour recompter 1h. N'est plus
	movwf	BT2		; utile car on ne compte pas les heures

it_timf	btfss	sect_on		; si pas de secteur (sect_on=0) incrmenter BT_pan qui
	incf	BT_pan,1	; en arrivant  32 soit 2,56s, dclenchera la mmorisation

	swapf	status_temp,0	; status retrouve son tat dans w
	movwf	STATUS		; puis repasse dans status sans modif de z
	swapf	w_temp,1
	swapf	w_temp,0	; w invers 2 fois revient  sa place bit Z non modifi

 	retfie

;************************************************************************************
; ****		 ms_1 	et une_ms		tempo de 1ms avec Quartz 3,2768Mhz 				*****
; *** appel avec chargement de dure mis dans W et utilisation de cnt
; *** par ex pour avoir 30ms, charger w=.30 avant le call ms_1
;************************************************************************************

une_ms	movlw	1		; avec call une_ms on a une ms en prchargeant W  1
ms_1	movwf	ms1
ms1a	movlw	.204		; ici on charge une boucle de 204 pas 
	movwf	cnt
ms1b	decf	cnt,1
	btfss	testz		; que l'on dcrmente pour faire la tempo de 1ms
	goto	ms1b
	decfsz	ms1,1
	goto	ms1a
	return

;**************************************************************************************
; ***		ms_10		et dix_ms **** 	sous programme tempo de 10ms	***
;  dure allant de 0  2550ms (= 2,5s) passe par W	(utilisation de ms_1)
;**************************************************************************************

dix_ms	movlw	1		; en appelant dix_ms on a 10ms car on met W=1
ms_10	movwf	ms10		; sinon on autant de fois 10ms que le contenu de ms10

ms10a	movlw	.10		; on charge w  10 et on appelle ms1 pour obtenir 10ms
	call	ms_1
	decfsz	ms10,1		; on dcrmente ms10 puis on teste si ms10 arrive  0
	goto	ms10a		; on appelle ms_1 charg  10ms
	return			; jusqu' ce que la tempo voulue soit atteinte

;***************************************************************************************
;***************************************************************************************
;				programme principal
;***************************************************************************************
;***************************************************************************************

DEBUT	clrf	PORTA		; initialisation des ports
	clrf	PORTB
	bsf	banq		; selection banquek 1
	clrf	TRISB		; on met tout le PORTB en sortie, PB est en entre au reset
				; le port A est en entre d'office au RESET
	movlw	0xD7		; 1101 0111  T0CS=0 (timer interne), PSA=0 (prdiv timer) 
	movwf	OPTION_REG	; PS2,1,0 =111 ==>(div 256)
	bcf	banq		; retour bank 0

inivar	movlw	0x12		; variables en RAM mises  0  partir de BT_pan 
	movwf	FSR
inivar1	clrf	INDF		; 
	incf	FSR,1
	movlw	0x36		; adresse de la dernire variable 	
	subwf	FSR,0
	btfss	testz
	goto	inivar1

	call	lec_cpe		; transfert de CPE mmorise en E2PROM dans la RAM
  
;	*****	alimentation de l'afficheur aprs tempo de 7,5s pour que la tension 
; 		d'alimentation qui croit lentement soit assez leve pour le LCD
;		sinon on n'a pas de raz "hard" correcte du LCD mme avec son init

lcd_on	movlw	.3		; ralisation d'une tempo de 7,5 s pour que la tension
	movwf	var1		; d'alim monte assez haut pour l'afficheur
lcd_2	movlw	.255
	call	ms_10
	decfsz	var1,1
	goto	lcd_2

	bsf	alim_af		; attente de 7,5s avant d'alimenter l'afficheur par RB1

	call	aff_ini		; initialisation de l'afficheur en mode 4 bits

; ****	Y a t il eu panne secteur (ps) entrainant la RAZ prcdente ou pas

	movlw	F_panne		; on va lire si la rinitialisation est due  une panne
	call	lec_e2p		; dans ce cas F_panne=1 (DONC Z=0). si Z=1 reset normal
	btfss	testz		; aprs une panne on ne modifie ni P, ni la date
	goto	ret_ps		; ici le bit Z=0 donc il y a eu panne secteur

; ***	Ici le reset est du  une action de l'utilisateur donc il doit ventuellement 
; 	modifier P (s'il le souhaite) et la date de dpart du futur comptage.

modif_p	call	ec_puis		; ici on affiche MODIFICATION DE P=val KW O/N? +V 
				; pour savoir si on veut la modifier  

	movlw	p_kw		; l'adresse de la variable  modifier passe dans W 
	call	lec_e2p		; la valeur de la variable passe dans EEDATA et W 
	movwf	var1		; et enfin dans var1

	movlw	pmin		; On va maintenant chercher la valeur pmin de la variable dans
	movwf	var2		; que l'on met dans var2
	
	movlw	pmax		; on met la valeur maxi de la puissance dans var3
	movwf	var3		; utilis par le SP modvar comme var 1 et var 2

	movlw	pospuis		; on indique la place du curseur pour modifier P
	movwf	posicur
	call	pos_cur		; et on le positionne

	bsf	durinac,0	; pour ne pas sortir de at_clav de suite avant action
	call	at_clav		; boucle d'attente d'appui
	call 	clavier		; on en sort quand le clavier est relach avec clava et les 
 				; tmoin des touches actives positionns

	btfss	t_oui		; si la touche oui a t active, ce tmoin est  1
	goto	modif_d		; t_oui=0 on ne veut pas modifier P on va voir la date

	call	at_clav		; On doit confirmer la modif de P en appuyant sur Valid
	call 	clavier		; on en sort quand le clavier est relach avec clava et les 
 				; tmoin des touches actives positionns

	btfss	t_val		; si valid a t active, ce tmoin est  1
	goto	modif_d		; sans validation on garde P (ancien)

	bsf	t_modp		; ce bit mis  1 permet de traiter P qui est un nb dcimal
	call	modvar		; Appel de modif de la puissance, puis stockage en e2prom.
	bcf	t_modp		; remise  0 du bit aprs modif de P

memodeP	movf	var1,0		; Aprs modif, on transfre var1 (=P) dans W puis ds EEDATA
	movwf	EEDATA
	movlw	p_kw		; on met l'adresse de stockage en E2PROM dans EEADR
	movwf	EEADR
	call	ph_wre2		; on crit var1 modifie dans l'E2PROM

;	***	la phase de modif et la nouvelle valeur de P sont enregistres, il reste
;	***	 entrer la date courante, dbut de nouvelle priode de comptage

modif_d	bcf	t_afct		; permet l'affichage de la date courante
	call	ec_date		; ici on affiche "ENTRER DATE"  et la date

modif_j	movlw	date_c		; l'adresse de date_c (le jour) passe dans W 
	call	lec_e2p		; la valeur du jour passe dans EEDATA et W 
	movwf	var1		; et enfin dans var1

	movlw	1		; on met 1 comme valeur min pour le jour d'un mois
	movwf	var2		; que l'on met dans var2
	
	movlw	.31		; on met la valeur max du nb de jours dans 1 mois dans var3
	movwf	var3		; utilis par le SP modvar comme var 1 et var 2

	movlw	posJJ		; on indique la place du curseur pour modifier le jour
	movwf	posicur

	call	modvar		; Appel de modif du jour du mois, puis stockage en e2prom.

memodeJ	movf	var1,0		; Aprs modif, on transfre var1 (=Jour) dans W puis ds EEDATA
	movwf	EEDATA
	movlw	date_c		; on met l'adresse de stockage en E2PROM dans EEADR
	movwf	EEADR
	call	ph_wre2		; on crit var1 modifie dans l'E2PROM

modif_m	movlw	date_c+1	; l'adresse de date_c +1 (le mois) passe dans W 
	call	lec_e2p		; la valeur du jour passe dans EEDATA et W 
	movwf	var1		; et enfin dans var1

	movlw	1		; on met 1 comme valeur min pour le nb de mois
	movwf	var2		; que l'on met dans var2
	
	movlw	.12		; on met la valeur max du nb de mois dans var3
	movwf	var3		; utilis par le SP modvar comme var 1 et var 2

	movlw	posMM		; on indique la place du curseur pour modifier le mois
	movwf	posicur

	call	modvar		; Appel de modif du jour du mois, puis stockage en e2prom.

memodeM	movf	var1,0		; Aprs modif, on transfre var1 (=Mois) dans W puis ds EEDATA
	movwf	EEDATA
	movlw	date_c+1	; on met l'adresse de stockage en E2PROM dans EEADR
	movwf	EEADR
	call	ph_wre2		; on crit var1 modifie dans l'E2PROM

modif_a	movlw	date_c+2	; l'adresse de date_c+2 (l'anne) passe dans W 
	call	lec_e2p		; la valeur du jour passe dans EEDATA et W 
	movwf	var1		; et enfin dans var1

	movlw	.6		; on met 6 comme valeur min pour l'anne 2006
	movwf	var2		; que l'on met dans var2
	
	movlw	.99		; on met la valeur max 99 pour 2099 dans var3
	movwf	var3		; utilis par le SP modvar comme var 1 et var 2

	movlw	posAA		; on indique la place du curseur pour modifier le jour
	movwf	posicur

;	bsf	durinac,0	; pour ne pas sortir de at_clav de suite avant action
	call	modvar		; Appel de modif de l'anne, puis stockage en e2prom.

memodeA	movf	var1,0		; Aprs modif, var1 (=Anne) mis ds W puis ds EEDATA
	movwf	EEDATA
	movlw	date_c+2	; on met l'adresse de stockage en E2PROM dans EEADR
	movwf	EEADR
	call	ph_wre2		; on crit var1 modifie dans l'E2PROM

;	la validit de la date va tre teste (31 jour en fvrier est une erreur par ex)

verif_d	movlw	date_c+1	; chargement de l'adresse d'enregistrement du mois
	call	lec_e2p
	movlw	.4
	subwf	EEDATA,0	; est ce AVRIL qui n'a que 30 jours
	btfsc	testz
	goto	verif30		; si oui aller voir si on n'a pas mis le 31 comme jour.
	movlw	.6
	subwf	EEDATA,0	; est ce JUIN qui n'a que 30 jours
	btfsc	testz
	goto	verif30
	movlw	.9
	subwf	EEDATA,0	; est ce SEPTEMBRE qui n'a que 30 jours
	btfsc	testz
	goto	verif30
	movlw	.11
	subwf	EEDATA,0	; est ce NOVEMBRE qui n'a que 30 jours
	btfsc	testz
	goto	verif30
	movlw	.2
	subwf	EEDATA,0	; est ce FEVRIER qui n'a que 28 ou 29 jours
	btfss	testz
	goto	ret_ps		; le mois enregistr a 31 jours donc date correcte

verif_a	movlw	date_c+2	; ici le mois tant FEVRIER, on a charge l'adresse de
	call	lec_e2p		; l'anne et on lit celle ci.
	rrf	EEDATA,1	; est ce une anne bisextile? si oui le bit C reste  zro
	btfsc	testc		; pendant 2 rotations  droite
	goto	verif28		; ici C=1 donc anne non bisextile
	rrf	EEDATA,1
	btfsc	testc		; ici encore C doit tre nul pour que l'anne soit bis
	goto	verif28		; car anne non bisextile

verif29	movlw	date_c		; chargement de l'adresse d'enregistrement du jour
	call	lec_e2p		; lecture du jour pour verif qu'il est < ou =  29
	sublw	.29
	btfsc	testc		; si 29 < JJ==>C=0  ==> erreur de saisie
	goto	ret_ps		; ici C=1 donc JJ < ou = 29 donc pas d'erreur de date
	goto	error_d

verif28	movlw	date_c		; chargement de l'adresse d'enregistrement du jour
	call	lec_e2p		; lecture du jour pour verif qu'il est < ou =  28
	sublw	.28
	btfsc	testc		; si 28<JJ==>C=0  ==> erreur de saisie
	goto	ret_ps		; ici C=1 donc JJ < ou = 28 donc pas d'erreur de date
	goto	error_d

verif30	movlw	date_c		; chargement de l'adresse d'enregistrement du jour
	call	lec_e2p		; lecture du jour pour vrif qu'il est < ou =  30
	sublw	.30
	btfsc	testc		; si 30 <JJ ==> C=0  ==> erreur de saisie
	goto	ret_ps		; ici C=1 donc JJ < ou = 30 donc pas d'erreur de date

error_d	call	eff_lcd
	movlw	mess9		; afficher "CORRIGER DATE"
	call	af_lign
	bcf	t_afct
	call	af_date		; afficher la date du dernier enregistrement et 
	goto	modif_j		; ressaisir celle ci correctement

;  ***	la puissance tant modifie, la date courante initialise sans erreur de saisie, 
;  ***	on dmarre BT (base de temps: It autorises) puis on affiche l'cran par dfaut.
;  ***	On calcule au pralable P/2 et P/4 pour les dbuts et fins de conso

ret_ps	movlw	p_kw		; l'adresse de la puissance en E2PROM est mise dans W 
	call	lec_e2p		; on en revient avec P dans EEDATA et W 
	bcf	STATUS,0	; effacement du bit Carry avant division par 2
	rrf	EEDATA,0	; division de p_kw mise dans W
	movwf	demi_p
	bcf	STATUS,0	; effacement du bit Carry avant nouvelle division par 2
	rrf	demi_p,0
	movwf	quart_p		;

;  ***	annulation du flag panne secteur (fps) (en E2PROM) s'il tait  1

sup_fps	movlw	F_panne
	movwf	EEADR		; on prcharge EEADR puisqu'on en dispose dans W
	call	lec_e2p
	btfsc	testz		; si bit Z=1 alors il n'y avait pas eu panne
	goto	ini_BT		; donc ne pas effacer le F_panne
	clrf	EEDATA
	call	ph_wre2		; on vient de recharger F_panne avec 0

ini_tem	btfsc	mes_i		; comme tmesi_v=0 aprs init, si mes_i=1 (pas de conso), 
	bsf	tmesi_v		; on positionne tmesi_v dans le mme tat. 

ini_BT	movlw	.225
	movwf	BT1		; prchargement de BT1  225 POUR AVOIR 18s
	movlw	.200
	movwf	BT2		; Prchargement de BT2=200 pour avoir 1 heure (inutilis)
	clrf	TMR0		; TMR0 initialis  0 
	bsf	INTCON,T0IE	; autorise it timer
	bsf	INTCON,GIE	; autorise it gnrales
	goto	aff_1		; aprs reset, on ne doit pas augmenter la conso

; ***************************************************************************************
; addition de CP et P/100 qui sont en BCD utilise FSR et le bit "retenue"	
; ***************************************************************************************

aug_cp	bcf	retenue		; prpositionnement de retenue  0
	movlw	consop1
	movwf	FSR		; on met l'adresse de consop1 dans FSR

	btfss	t_pauxi		; si t_pauxi=1, on ajoute pauxi
	goto	augcpa
	movf	pauxi,0		; pauxi remplace P_KW car la priode de dbut ou de fin
	bcf	t_pauxi		; de conso n'est pas gale  36s (intervalle entre 2 IT)
	goto	augcpb

augcpa	movlw	p_kw
	call	lec_e2p		; la puissance  ajouter passe dans EEDATA
augcpb	addwf	INDF,1		; w=valeur de P est ajoute  la conso partielle1
augcp1	btfsc	retenue		; si retenue = 0 on n'ajoute rien sinon on ajoute 1
	incf	INDF,1		;  CP1, c'est le cas ici (si on y vient)
	movlw	.100
	subwf	INDF,0		; on teste si l'addition dpasse 100
	btfss	testc		; si c=0 CP<100
	goto	augcp2		; C=0 donc on conserve le rsultat contenu dans CP1
	movwf	INDF		; CP-100 passe dans CP1 car on dpassait 99
	bsf	retenue
	incf	FSR,1		; on passe l'adresse de CP suivant
	movf	FSR,0
	sublw	consop4		; si FSR=W>consop4=lit alors lit-W<0==> C=0
	btfsc	testc		; 
	goto	augcp1		; ici consop4>=FSR donc C=1 ==> continuez l'opration
				; d'addition
augcp2	bcf	retenue		; l on a fini soit parce que les 4 nb de la conso
				; ont t traits soit parce que la retenue est nulle
	clrf	pauxi		; pauxi est remis  0 aprs affichage

; ***	la conso a t incrmente, donc on va afficher la nouvelle valeur

aff_1	bcf	t_afct		; si t_adwh tait   1, c'est que la conso venait d'augmenter
aff_2	bcf	t_adwh		; si on vient ici, on pourra afficher CT ou CP suivant la
	call	ec_per		; valeur du bit t_afct

attente	btfsc	t_adwh		; aprs une augmentation de conso on doit modifier l'cran 
	goto	aug_cp		; ici t_adwh=1 ==> augmenter CP + affichage complet (CP et NBJ)

	btfsc	mes_i		; si mes_i = 0, il y a conso donc on met ledcons  1
	goto	conso_0		; mes_i=1 donc pas de conso
	bsf	ledcons
	goto	atten1
conso_0	bcf	ledcons
	btfsc	sect_on		; S'il y a panne secteur alors mes_i=1 et sect_on =0  
	goto	atten1		; ici sect_on=1 donc pas de panne
	btfss	BT_pan,4	; tester si on a eu 32 it de 80ms soit 2,56s de panne
	goto	atten1a		; ici on n'est pas encore  2,56s de panne
	call	memo_cp		; l on a dpass les 2,56s==> mettre CP dans CPE
	call	flag_ps		; mettre le flg panne  1

at_fps	btfss	sect_on		; attente fin de panne secteur
	goto	at_fps		; secteur non revenu => boucler sur attente_fin_panne_secteur
	goto	DEBUT		; secteur revenu rapidement, aprs panne de plus de 2,56s
				; avec sauvegarde de CP nanmoins on recommence tout pour
				; tre certain d'avoir une bonne rinitialisation

atten1	clrf	BT_pan		; en absence de panne on initialise BT_pan  chaque passage
atten1a	movf	PORTA,0		; surveillance clavier bits 0, 1, 2
	andlw	0x07		; masque pour ne voir que le clavier
	btfsc	testz
	goto	attente		; Z=1	pas d'action clavier donc on boucle sur attente

;  ****	il y a une action clavier en cours donc on dtermine son type pendant que celui  
;	ci n'est pas encore relach, donc on va lire les touches actives

	call 	clavier		; une touche a t active donc on va saisir sa valeur

; ****	Dtermination du type d'action en fonction des touches actives

atten2	btfsc	t_oetv		; si on a appuy sur OUI et Valid en mme temps
	goto	mem_c		; appel cran: veut on stocker la conso
	
	btfsc	t_afct		; appui sur Oui seul ou Non donc appel cran diffrent
	goto	aff_1		; on va afficher l'cran CP en inversant t_afct
	bsf	t_afct		; on inverse t_afct et on va afficher la Conso Totale
	goto	aff_2		; en allant  aff_2

; ****	On veut autre chose que l'affichage d'un autre cran donc on cherche si l'on
; ****	veut mmoriser la conso, opration obligatoire avant de modifier la puissance
; ****  si c'est ce que l'on souhaite 

mem_c	call	ec_memo		; On affiche l'cran
	bsf	durinac,2	; init de la dure de passage dans les menus 4x18s max
	call	at_clav		; 	STOCKER CP O/N? + V
	call	clavier		; on attend un appui sur OUI suivi d'un appui sur Valid
	btfss	t_oui
	goto	aff_1
	call	at_clav		; a prs relchement de la touche OUI, on attend une
	call	clavier		; nouvelle action sur le clavier avec at_clav
	btfss	t_val
	goto	aff_1		; si on ne valide pas on retourne  l'affichage

; ***************************************************************************************
; ici, on a rpondu OUI et on a valid, on veut effectuer le cumul de  CP avec CT
; chaque nombre issu d'un octet CT ou CP est <99 et aprs addition le sera encore par 
; traitement qui entrainera une retenue  transfrer sur la somme suivante
; l'addition de CP et CT (nb BCD) utilise FSR, et randata + le bit retenue	
; une fois la conso CP+CT calcule, le rsultat prsent dans CP doit passer en E2PROM.
; L' IT du TIMER EST INTERDITE PENDANT TOUTE CETTE OPERATION 
; ***************************************************************************************

ajou_cp	bcf	INTCON,T0IE	; IT TIMER INTERDITES	 

	call	eff_lcd	
	movlw	mess10		; affichage "CUMUL DES CONSO"
	call	af_lign
	movlw	mess11		; "EN COURS"
	call	af_lign

	bcf	retenue		; prpositionnement de retenue  0
	clrf	randata
ajoucp1	movlw	consot1
	addwf	randata,0	; on met l'adresse de consot1 dans EEADR
	movwf	EEADR
	bsf	banq
	bsf	EECON1,RD	; lecture de consot1
	bcf	banq	
	movlw	consop1
	addwf	randata,0
	movwf	FSR		; FSR contient l'adresse de consop1
	movf	EEDATA,0
	addwf	INDF,1		; on ajoute consot1 et consop1 dans consop1

ajoucp2	btfsc	retenue		; si retenue = 0 on n'ajoute rien sinon on ajoute 1
	incf	INDF,1		;  CP1, c'est le cas ici (si on y vient)
	movlw	.100
	subwf	INDF,0		; on teste si l'addition dpasse 100
	btfss	testc		; si c=0 CP<100 si c=1 CP>=100 donc on conserve CP-100
	goto	ajoucp3		; C=0 donc on conserve le rsultat contenu dans CP1
	movwf	INDF		; CP-100 passe dans CP1 car on dpassait 99
	bsf	retenue		; retenue=1 car CP>=100 ici
	goto	ajoucp4

; *** on va faire passer le rsultat de CT+CP (actuellement dans CP) en E2PROM
; *** comme on est  la bonne adresse EEADR, il suffit de mettre CP dans EEDATA puis 
; *** d'appeler le SP de stockage en E2PROM

ajoucp3	bcf	retenue		; l'addition tant <100 on met retenue  0
ajoucp4	movf	INDF,0		; le rsultat de l'addition passe dans W puis dans EEDATA
	movwf	EEDATA

	CALL	ph_wre2		; appel du sous prog de stockage en E2PROM

	clrf	INDF		; effacement de CP aprs le cumul avec CT 

	incf	randata,1	; on passe l'adresse de CP suivant
	movf	randata,0
	sublw	4		; si randata=4 alors on a trait les 4 additions
	btfss	testz		; 
	goto	ajoucp1		; ici randata<4 ==> continuez l'opration d'addition

; ***	CP+CT a t stocke. De plus, CP a t mise  0. Il reste  transfrer CP=0 dans CPe 
; ***	sinon au redmarrage du programme on repartira avec une CP non nulle. Ensuite on  
; ***	demandera s'il faut modifier P et noter la nouvelle date en retournant en dbut de
; ***	programme. On y rinitialisera les variables BT1 et BT2, CP1  CP4 etc.
; ***	
	call	memo_cp		; permet d'effacer CPe pour qu'aprs le cumul et le reset
				;  l'appel de CPe, on ait CP=0.

	bcf	INTCON,GIE	; pour pouvoir ventuellement remodifier la puissance	
	
	movlw	.200
	call	ms_10		; attente 2 secondes pour lecture du message

	movlw	mess12		; "EN COURS" est remplac par "TERMINE "
	call	af_lign

	movlw	.200
	call	ms_10		; attente 2 secondes pour lecture du message

	goto	modif_p		; retour  l'cran de modif de P (sans reset complet)

; **************		FIN DU PROGRAMME PRINCIPAL	**********************

;	***************************************************************************
;	aff_ini sous prog d'initialisation de l'afficheur LCD en mode 4 bits
;	***************************************************************************

aff_ini	movlw	.32		; tempo de 32ms 
	call	ms_1

	bcf	LCD_RS		; Mode commande pour le LCD

; envoi de la squence d'initialisation du LCD en mode 4 bits

	bsf	LCD_B4		; on envoie la valeur binaire 0011 
	bsf	LCD_B5		; sur le bus 4 bits du LCD
	bcf	LCD_B6
	bcf	LCD_B7

	call	val_lcd

	movlw	.8		; maintien de E  0 pendant encore 8ms
	call	ms_1

	call	val_lcd		; envoi du code 0011 une seconde fois valid par E
	call	val_lcd		; envoi du code 0011 une troisime fois valid par E

	bcf	LCD_B4		; le mot binaire est maintenant 0010 (MODE 4 BITS)
	call	val_lcd

	movlw	0x28		; DL=0	soit 4 bits et N=1 donc 2 lignes de caractres
	call	sendbyt	 

	movlw	0x08		
	call	sendbyt		; display Off cursor Off, Blink (clignotement) OFF

	movlw	0x01		; 
	call	sendbyt		; effacement de l'affichage

	movlw	.4		; tempo de 4ms pour l'effacement du LCD
	call	ms_1

	movlw	0x06		; mode de fonctionnement I/D=1 et S=0 incrment automatique
	call	sendbyt		; sans dcalage de l'affichage

; *** 	FIN DE LA PHASE D'INITIALISATION DE L'AFFICHEUR EN MODE 4 BITS
; ***		on doit maintenant autoriser l'affichage

	movlw	0x0F		; display ON, cursor ON et clignottement du caractre
	call	sendbyt

	return

;	*****************************************************************************
;	send_d, send_c,	sendbyt	ces SP prennent l'octet dans W pour l'envoyer au LCD
;	send_d envoie une donne et send_c une commande
;	*****************************************************************************

send_d	bsf	LCD_RS		; mode d'envoi de donnes
	goto	sendbyt

send_c	bcf	LCD_RS		; mode envoi d'une commande

sendbyt	bsf	poids_f		; ce bit est  1 pour l'envoi du quartet haut de l'octet
	movwf	tampon		; tampon reoit le code du caractre  transmettre
sdbyt1	swapf	tampon,1	; inversion des quartets haut et bas pour envoyer le 
	movlw	0x0F		; quartet haut en premier
	andwf	PORTB,1		; les 4 bits de donne du LCD passent  0
	
	btfsc	tampon,0	; ces 4 tests successifs permettent de positionner
	bsf	LCD_B4		; les bits 4  7 du LCD  la valeur voulue
	btfsc	tampon,1
	bsf	LCD_B5
	btfsc	tampon,2
	bsf	LCD_B6
	btfsc	tampon,3
	bsf	LCD_B7

	call	val_lcd		; signal de valid E (1ms ="1" puis 1ms ="0")

	btfss	poids_f		; si poids_f=1 on saute pour le mettre  zro

	return			; ici poids_f=0 donc les 2 quartets ont t mis

	bcf	poids_f		; on va envoyer le 2 quartet (poids faible)
	goto	sdbyt1

; 	*************************************************************************
;	val_lcd		sous programme gnrant le signal E  appliquer au lcd
;	*************************************************************************

val_lcd	bsf	LCD_E		; E mis  1 pendant 1ms
	call	une_ms		; tempo de 1ms
	bcf	LCD_E		; E remis  zro 1ms
	call	une_ms		
	return

;	***************************************************************************
;	eff_lcd		efface l'afficheur et remet le curseur 1 ligne, 1 colonne
;	***************************************************************************

eff_lcd	movlw	0x01		; code d'effacement de l'affichage
	call	send_c

	movlw	2		; tempo attente de 2ms pour l'effacement du LCD
	call	ms_1

	return

;	***************************************************************************
;	pos_cur		positionne le curseur sur la  1 ou 2 ligne suivant que W
;	contient Ox0n ou Ox4n. (n+1) reprsente la colonne ou sera affich le 1
;	caractre (pour n=3 le curseur passe en colonne 4). La position du curseur
;	passe par W avant le call pos_cur
;	***************************************************************************

pos_cur	addlw	0x80		; le 1 binaire en tte indique qu'on envoie une
	call	send_c		; adresse. il s'agit d'une commande
	return

;	****************************************************************************
;	af_lign		permet d'afficher un message lu dans la mmoire de programme
;	prlev avec des RETLW. L'adresse du message passe par W. La ligne et le  
; 	nb de caractres passent par 2 codes au dbut de chaque message.
;	****************************************************************************

af_lign	clrf	count		; le comptage des retlw est prcharg  0 + le rang du 
	addwf	count,1		; message qui est contenu dans W (=messn)

	movf	count,0		; W reoit le rang du retlw par ajout au compteur PC
	call	mess		; retour avec position curseur (1 code du message)
	call	pos_cur		; dans W
af_mess	incf	count,1
	movf	count,0		; on va lire le 2 code du message (le nb de caractres)
	call	mess
	movwf	nbcar		; nb de caractres utiles sans la place et le nb
conti	incf	count,1
	movf	count,0		; ici on lit les codes successifs du message 
	call	mess		; (code ASCII des caractres mis dans W) qui sont ensuite 

	call	send_d		; affichs par cette instruction
	decfsz	nbcar,1
	goto	conti		; boucle sur les n caractres du message

	return

;  	********************************************************************************
;	ec_memo		cran affich pour STOCKER LA CONSO. Ncessite mess4 et mess5
;		utilise var1 et var2 et FSR
;	*********************************************************************************

ec_memo	call	eff_lcd
	movlw	mess4		; criture de STOCKER CONSO
	call	af_lign		; 
	movlw	mess5		; O/N? + V
	call	af_lign 
	return

;  	********************************************************************************
;	ec_puis		cran affich pour 	MODIFICATION DE
;					 	P=   KW O/N? + V
;	 Ncessite mess6 et mess5
;		utilise var1 et var2 et FSR
;	*********************************************************************************

ec_puis	call	eff_lcd
	movlw	mess6		; criture de "MODIFICATION DE" et de  "O/N? + V"
	call	af_lign		; on enchaine sur l'affichage de la PUISSANCE qui est un sous
	movlw	mess5
	call	af_lign		; programme que l'on peut aussi appeler.

;  	********************************************************************************
;	af_pkw		permet d'crire sur la 2 ligne la puissance P= , KW
;			utilise mess7 (P=) puis affiche la valeur de P
;			lue en E2PROM puis crit en suivant KW 
;	*********************************************************************************

af_pkw	movlw	mess7		; criture de " P= "
	call	af_lign

	btfss	t_modp		; si t_modp=1, on est en cours de modif de la valeur de P
	goto	af_pkw1		; s'il est  zro, on prend la valeur en E2PROM
	movf	var1,0		; l on prend var 1 qui contient la valeur de P modifie
	goto	af_pkw2

af_pkw1	movlw	p_kw		; adresse en E2PROM de la puissance soit .3
	call	lec_e2p		; on reoit dans EEDATA la valeur de la puissance mmorise
af_pkw2	clrf	blank		; aucun 0 enlev
	call	cv_bcd		; aprs conversion en BCD, on l'affiche
	bsf	sep_ud		; ce bit mis  un permet d'introduire une virgule entre les
	call	af_du		; 2 chiffres constitutifs de p_kw
	movlw	'K'
	call	send_d		; envoi de la lettre K  la suite de la puissance
	movlw	'W'
	call	send_d		; envoi de W (pour Watt) soit des KW 
	return	

;	*******************************************************************************
;	ec_date		affiche "entrer nouvelle date" pour l'cran de modif de celle ci
;	*******************************************************************************

ec_date	call	eff_lcd		; effacement complet avant criture de "ENTRER DATE"
	movlw	mess8		; on enchaine sur l'affichage de la date initiale ou 
	call	af_lign		; intermdiaire suivant le bit t_afct (1 pour initiale)

;  	********************************************************************************
;	af_date		sous prog pour METTRE JJ/MM/AA
;	avec criture des sparateurs de la date JJ/MM/AA aprs JJ puis MM
;	*********************************************************************************
	
af_date	movlw	date_i		; prchargement de w 
	btfss	t_afct		; si t_afct=1 FSR reoit 0 (adresse de date initiale)
	movlw	date_c		; si t_afct=0 FSR reoit 8 (adresse de date courante)
	movwf	FSR		; 
	movlw	posdate		; le curseur est mis sur la dizaine de jours
	call 	pos_cur		; 
af_dat1	movf	FSR,0		; 
	call	lec_e2p		; dans EEDATA et W on a le jour de dmarrage du comptage
	call	cv_bcd		; aprs conversion en BCD, on l'affiche
	clrf	blank		; aucun zro ne sera effac et on ne teste pas les nb
	call	af_du		; pour savoir s'ils sont nuls
	movlw	date_i+2	; on cherche si on a affich JJ, MM, et AA 
	btfss	t_afct		; soit pour date_i soit pour date_c. si oui 
	movlw	date_c+2	; on vrifie si on a charg les 3 donnes JJ, MM, AA
	subwf	FSR,0		; si c'est le cas, FSR- adresse=0 ==>Z=1 donc on a fini
	btfsc	testz		; 
	goto	af_datf
	incf	FSR,1		; on n'a pas encore lu les 3 donnes donc on continue
	movlw	'/'		; on place un sparateur JJ/MM
	call	send_d		;  
	goto	af_dat1		; puis on va lire en E2PROM le mois et enfin l'anne
af_datf	return	

; **************************************************************************************
;	af_conso	Sous prog pour afficher la conso partielle ou totale
;			contenue en RAM (p) et en E2PROM (totale) 
;	avec le tmoin t_afct mis  1 avant le call af_conso on obtient la conso totale 
;	On utilise randata et consov comme variables ainsi que FSR. On commence par 
;	traiter et afficher la conso de poids fort (nb le plus  gauche)
; ***************************************************************************************

af_conso
	movlw	poswh		; placer le curseur en 0x03 pour afficher le chiffre des KWh
	call	pos_cur		; de poids le plus fort
	movlw	4
	movwf	randata		; on initialise randata  4
	movlw	3		; bk1 et bk2 mis  1
	movwf	blank		; initialisation de blank pour effacer les zros en tte

af_con1	btfss	t_afct		; si t_afct=1, on veut afficher la conso totale (en E2PROM)
	goto	lec_cp		; ici t_afct=0 donc on chargera la conso partielle

lec_ct	movlw	consot1-1	; ici on charge l'adresse de la conso totale
	addwf	randata,0	; au 1 coup on pointe consot4
	call	lec_e2p		; on reoit dans EEDATA et W la conso totale que l'on
	goto	af_con2		; on a la conso totale donc on va l'utiliser

; ***	l on fait passer la conso partielle dans consov

lec_cp	movlw	consop1-1	; adresse de la conso partielle mise dans W aprs ajout de
	addwf	randata,0	; randata. au 1 coup on pointe consop4
	movwf	FSR
	movf	INDF,0		; consop est mise dans W

; *** 	que ce soit la conso totale ou partielle on va l'afficher maintenant

af_con2	movwf	consov		; la conso CP ou CT est dplace dans consov
	movlw	2
	subwf	randata,0	; si randata=2 il faut mettre une virgule entre les quartets
	btfss	testz		; sparant les Wh et KWh (si Z=1 randata=2)
	goto	af_con3		; ici randata non =2 
	bsf	sep_ud		; ce bit vaut 1 car on veut une  virgule entre les Wh et KWh
	clrf	blank		; en mettant les bits bk1 et 2  0 on aura affichage des 0

af_con3	movf	consov,0	; passage de consov dans W avant affichage.
	call	tst_bk		; pour la 1 variable bk1,2 sont  11
	movf	consov,0		
	call	cv_bcd		; aprs conversion en BCD, on affichera les 2 chiffres de
	call	af_du		; poids diminuant avec effacement des 0 en tte
	decfsz	randata,1
	goto	af_con1		; aller afficher les autres chiffres de la conso

	return

;  	********************************************************************************
;	ec_per	Si t_afct mis  1 avant appel on affiche la Conso totale, la Puissance
;		la date de mise en service initiale.
;		Si t_afct=0 on affiche la conso partielle, la puissance et la date 
;		depuis le dernier stockage de conso partielle (cran par dfaut)
;	*********************************************************************************

ec_per	call	eff_lcd		; effacement complet de l'afficheur
	movlw	mess3		; criture de KWh
	call	af_lign
	call 	af_pkw		; affichage de la puissance
	btfsc	t_afct		; si t_afct=1 on veut la conso totale et  0 la conso
	goto	ec_ct		; partielle
ec_cp	movlw	mess1		; criture du texte de la 1 ligne " CP= "
	call	af_lign
	goto	ec_per2
ec_ct	movlw	mess2		; criture du texte de la 1 ligne " CT= "
	call	af_lign
ec_per2	call	af_date

	call	af_conso	; le bit t_afct slectionne le type de conso affiche 

	btfss	mes_i		; si il y a conso en cours, mes_i=0, alors on laisse 
	goto	ec_perf		; le curseur clignoter aprs les Wh. sinon on le fait
	movlw	0x10		; sortir de l'cran ce qui peut indiquer l'absence ou  
	call	pos_cur		; la prsence de conso sans led externe.

ec_perf	return

; ***************************************************************************************
;	tst_bk 	
;		test un nombre <99 pour savoir s'il va tre possible d'effacer les zro
; inutiles en tte sur l'afficheur (ex: crire 5 au lieu de 05)
; Pour un nombre  4 ( ou plus de chiffres) avec les tmoins bk1 et bk2 mis  1 on sait
; si les chiffres suivant peuvent aussi tre blanchis ou pas.
; le nombre  tudier doit passer par W et sera trait dans var1.
; 	Pour un nb comme 2345, avant le test sur 23, il faut mettre blank=00000011 avant
; d'appeler le prog "tst_bk" pour que les tests puissent se faire. Aprs passage dans
; tst_bk, suivant la valeur du nb trait le rsultat est le suivant
; Exemple: si var1=12 	B1B2=00	  si  var1=09 B1B2=10 ==> affichage "9" var1=00 B1B2=11
; Pour que les zro soient conservs, mettre blank=00 avant l'appel de af_du et ne pas 
; appeler tst_bk pour traiter les nombres  afficher (ex la date car pour Fvrier 02 est
; mieux que 2 tout seul) 	
; ***************************************************************************************

tst_bk	movwf	var1		; On met le nb  traiter dans var1
	movlw	.3
	subwf	blank,0		; si blank prcdent <3 inutile de traiter le nb var1, 
	btfss	testc		; car le nb prcdent n'tait pas nul donc il faut crire 
	goto	tst_b3		; les zro donc bk1=bk2=00 pour ce nouveau nb var1
	movf	var1,1		; si var1 (=nb  traiter) =0 on met bk1=bk2=1 pour avoir
	btfsc	testz		; des blancs au lieu des 0
	goto	tst_b2		; VAR1 est nulle donc on met blank=11
	movlw	.10
	subwf	var1,0		; si var1 <10 alors le bit C=0 et blank=10 le chiffre
	btfsc	testc		; des dizaines est nul
	goto	tst_b3
	bsf	bk1		; var1<10 ici donc bk1,2=10
	bcf	bk2
	goto	tst_bf
tst_b2	bsf	bk1		; VAR1=0 et var1 prcdent nul aussi
	bsf	bk2
	goto	tst_bf
tst_b3	clrf	blank		; var1>10 ou var1 prcdent non nul
tst_bf	return	

;****************************************************************************************
; 			af_du	(utilise var4)
; Prend les deux quartets d'un nb bcd (<99) et envoi les dizaines en premier au LCD
; 		l'octet  transfrer doit passer par W avant l'appel pour les zro 
; blanchir, on se sert des bits bk1 et bk2. S'ils sont  1, il doit y avoir blanchiement 
;  si la variable est un nombre dcimal (d,u), il faut mettre sep_ud=1 avant l'appel pour
;  insrer une virgule entre les 2 chiffres affichs.
;****************************************************************************************

af_du	movwf	var4		; octet mis dans var4

af_du1	swapf	var4,0		; passage du quartet fort en position basse pour le traiter
	andlw	0x0F		; masque le quartet faible pour laisser le quartet fort
	addlw	0x30		; donne le code ASCII

	btfsc	bk1		; si bk1=0 on peut afficher le chiffre des dizaines
	movlw	' '		; sinon on envoie un espace
	call	send_d		; envoi du code au LCD
	btfss	sep_ud		; si on a une variable dcimale  afficher comme P, alors
	goto	af_du2		; sep_ud=1 ce qui ==> afficher une virgule
	movlw	','		; ici on envoie la virgule avant d'afficher le 2 quartet
	call	send_d
		
af_du2	movf	var4,0		; le nb BCD est remis dans W
	andlw	0x0F		; masque le quartet fort pour laisser le quartet faible
	addlw	0x30		; donne le code ASCII
	btfsc	bk2		; si bk2=0 on peut afficher le chiffre des units
	movlw	' '		; sinon on envoie un espace
	call	send_d		; envoi du code ASCII au LCD

	bcf	sep_ud		; remise  zro de ce bit tmoin de sparation par virgule
	return

;***************************************************************************************
;		cv_bcd		(utilise var4 et var5)	
; conversion d'un nb binaire (<99) en un nb cod dcimal
;			le nb  convertir passe par w et ressort dans w
;***************************************************************************************

cv_bcd	clrf	var5
	movwf	var4		; reoit le nombre  convertir
cv_bcd1	incf	var5,1		
	movlw	.10
	subwf	var4,1
	btfsc	testc
	goto	cv_bcd3		; c=1 donc var4 > ou = 10
	movlw	.10		; ici var4 tait < 10
	addwf	var4,0		; on reconstitue l'unit de var4 dans W
	decf	var5,1
cv_bcd2	swapf	var5,1		; forme la dizaine de var4
	addwf	var5,0		; formation du nb cod dcimal dans W
	return

cv_bcd3	btfss	testz		; on teste si var4= 10n
	goto	cv_bcd1		; pas ici donc on continue  oter 10
	clrw
	goto	cv_bcd2

;***************************************************************************************
;	inc_var		SP d'incrmentation d'une variable se trouvant dans VAR1
;			ayant une valeur limite minimum mise dans VAR2 
;			et une valeur maximum situe dans VAR3
;			La variable augmente ressort dans VAR1 et aussi dans W
;			pas de retenue pour une autre variable ici
;***************************************************************************************

inc_var	movf	var3,0		; la limite max contenue dans var3 est mise dans W		
	subwf	var1,0		; si var1 est dj gale au maximum, on charge var1 avec
	btfsc	testz		; le minimum contenu dans var2 en allant  varmin
	goto	varmin				
	incf	var1,1		; sinon on incrmente var1 que l'on met aussi dans W	
	goto	incvarf
varmin	movf	var2,0		; le minimum passe dans W puis dans var1
	movwf	var1
incvarf	movf	var1,0

	return

;***************************************************************************************
;	dec_var		SP de dcrmentation d'une variable se trouvant dans VAR1
;			ayant une valeur limite minimum mise dans VAR2 
;			et une valeur maximum situe dans VAR3
;			La variable augmente ressort dans VAR1 et aussi dans W
;			pas de retenue pour une autre variable ici
;***************************************************************************************

dec_var	movf	var2,0		; la limite min contenue dans var2 est mise dans W		
	subwf	var1,0		; si var1 est dj gale au minimum, on charge var1 avec
	btfsc	testz		; le maximum contenu dans var3 en allant  varmax
	goto	varmax				
	decf	var1,1		; sinon on incrmente var1 que l'on met aussi dans W	
	goto	decvarf
varmax	movf	var3,0		; le maximum passe dans W puis dans var1
	movwf	var1
decvarf	movf	var1,0
	return

;**************************************************************************************
;	modvar	SP de modif d'une variable ( <100 ) passe par VAR1, de minimum pass  
; dans VAR2 et de maximum pass dans VAR3. La position de l'unit de la variable sur 
; l'cran est pospuis.
; La modification de la variable 8 bits ( <100 ) se fait par action sur le clavier. 
; La variable "durap" est modifie suivant que l'on a un appui court ou long sur les touches
; + ou - . Cela permet d'acclrer la vitesse de modification de la variable var1 en 
; cours de modification
;**************************************************************************************

modvar	movlw	.4
	movwf	durap		; init de durap pour vitesse lente

modv0b	movf	posicur,0	; curseur mis en place sur la variable  modifier
	call	pos_cur		; en mode clignotant

modv1	call	lecclav
	movwf	clava		; on met le contenu de W dans clava. Tant qu'il est nul
	btfsc	testz		; on boucle sur modvar en attente d'action
	goto	modvar		; clavier inactif donc boucle d'attente

	movf	durap,1		; il y a action sur une touche du clavier
	btfss	testz		; appui t-on depuis longtemps? si oui augmenter vitesse
	goto	modv2
	movlw	.16		; pas entre 2 variations de 160ms au lieu de 320 ms
	goto	modv3

modv2	decf	durap,1		; appui depuis peu donc on diminue durap
	movlw	.32		; on impose un pas de 320ms car appui depuis peu de temps

modv3	call	ms_10
acplus	movlw	.2
	subwf	clava,0
	btfss	testz		; a t-on appuy sur + ?
	goto	modv5		; NON donc aller voir si c'est sur -
	call	inc_var		; OUI donc incrmentation de la variable var1

modv4	btfss	t_modp		; si on modifie P on remet le curseur sur l'unit de P
	goto	modv4b		; au lieu des dci KW soit en posicur-2 (il y a une vir
	movlw	.2		; gule entre les 2 chiffres), alors que pour la date
	subwf	posicur,0	; on ne fait que dcaller d'un cran  gauche le curseur
	bsf	sep_ud		; permet d'crire la virgule 
modv4a	call	pos_cur
	clrf	blank		; on affiche les zro avant le jour, le mois, l'anne
	movf	var1,0
	call	cv_bcd
	call	af_du
	goto	modv0b		; retour au dbut pour continuer de modifier la variable
	 
modv4b	decf	posicur,0	; ce n'est pas P qui est modifi donc dcallage du
	goto	modv4a		; curseur d'un seul cran  gauche

modv5	movlw	.1		; gestion dcrmentation si touche - active
acmoins	subwf	clava,0
	btfss	testz		; a t-on appuy sur - ?
	goto	modv6		; NON donc aller voir si c'est la touche Validation
	call	dec_var		; OUI donc dcrmentation de var 1
	goto	modv4		; et maintenant on affiche le rsultat de la modif

modv6	movlw	.4		; Y a t'il eu appui sur v ?
acv	subwf	clava,0
	btfss	testz
	goto	modvar		; NON, mauvaise combinaison de touches actives

modv7	call	lecclav		; OUI, appui sur v en cours donc attente du relchement
	btfss	testz
	goto	modv7		; touche V active mais non relache donc attente

	return			; ici la touche V est relche, on sort du Sous Prog

;***************************************************************************************
; ***	memo_cp	***	SP charg de mmoriser CP dans CPe en E2PROM (si panne longue ou
;			aprs cumul et sauvegarde de CP+CT. dans ce cas CPe sera charg 
;			avec des valeurs nulles pour que l'on redmarre  0)
;
;***************************************************************************************

memo_cp	bcf	INTCON,T0IE	; it timer interdites
	clrf	randata
memo_1	movlw	consop1
	addwf	randata,0	; W contient randata+consop1 qui passe dans FSR
	movwf	FSR		; pour pointer consop1 puis consop2 etc
	movf	INDF,0		; le contenu de consop1 passe dans EEDATA
	movwf	EEDATA
	movlw	consope
	addwf	randata,0	; W contient randata+consope adresse de stockage en E2P
	movwf	EEADR

	call	ph_wre2		; criture en e2prom

	incf	randata,1
	movf	randata,0
	sublw	4
	btfss	testz		; si randata=4 z=1 donc on a charg les 4 lments de CP
	goto	memo_1
	return

;**************************************************************************************
;	flag_ps	****	SP charg de mettre l'info de panne secteur en E2PROM
; *************************************************************************************

flag_ps	movlw	F_panne
	movwf	EEADR		; chargement de l'adresse de F_panne
	movlw	1
	movwf	EEDATA		; charger 1 dans l'octet F_panne
	call	ph_wre2		; criture en e2prom

	return

;***************************************************************************************
; ***	lec_cpe	***	SP charg de transfrer CPe mmorise en E2PROM vers la RAM 
;		
;***************************************************************************************

lec_cpe	clrf	randata
lec_1	movlw	consope
	addwf	randata,0	; W contient randata+consope adresse de stockage en E2P
	movwf	EEADR
	bsf	banq
	bsf	EECON1,RD	; lecture de la donne en E2PROM , le rsultat est dans 
	bcf	banq		; EEDATA
	movlw	consop1
	addwf	randata,0	; W contient randata+consop1 qui passe dans FSR
	movwf	FSR		; pour pointer consop1 puis consop2 etc
	movf	EEDATA,0
	movwf	INDF		; le contenu de EEDATA passe dans consop1  

	incf	randata,1
	movf	randata,0
	sublw	4
	btfss	testz		; si randata=4 z=1 donc on a charg les 4 lments de CP
	goto	lec_1

	return

;***************************************************************************************
; ***	lec_e2p	***	lecture d'un octet en E2PROM dont l'adresse passe par W
;		la donne revient dans EEDATA et aussi dans W
;***************************************************************************************

lec_e2p	movwf	EEADR		; l'adresse de la donne est mise dans EEADR
	bsf	banq		; On donne l'ordre de lecture en mettant le bit RD de 
	bsf	EECON1,RD	; EECON1  1. Le rsultat passe dans EEDATA
	bcf	banq
	movf	EEDATA,0	; que l'on met en plus dans W pour utilisation
	return

; **************************************************************************************
;	ph_wre2		Procdure d'criture en E2PROM d'un octet dj plac dans EEDATA
;			et dont l'adresse est elle aussi dj place dans EEADR
; **************************************************************************************

ph_wre2	bsf	banq
	bsf	INTCON,EEIE	; on autorise les it de l'e2prom
	bcf	INTCON,GIE	; it invalides
	bsf	EECON1,WREN	; prparation des registres pour l'criture
	movlw	0x55
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	bsf	EECON1,WR
	bsf	INTCON,GIE	; autorisation des it  nouveau (fin de la mise en e2prom)

phwr1	btfss	pass		; le bit pass est mis  1 dans l'it d'criture en E2P
	goto	phwr1		; boucle d'attente de fin d'criture de l'octet
	bcf	INTCON,EEIE	; dsactivation des IT de l'E2PROM
	bcf	pass

	return

	end
	

